# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl HTML-TreeBuilder-toSAX.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

my @html;
BEGIN { my @html= glob( "t/*.html") }

use Test::More tests => 1 + @html;
BEGIN { use_ok('HTML::TreeBuilder::toSAX') };

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

foreach my $html (@html)
  { (my $basename= $html)=~ s{.html}{};
    my $tree= load_tree( $html);
    my $sax2= "$basename.sax2";
    open( my $dump, '>', $sax2) or die "cannot create file $sax2: $!";
    my $dumper= HTML::TreeBuilder::toSAX::Dump->new( $dump);
    $tree->toSax2( $dump);
    nok( diff( $sax2 => "$basename.expected.sax2"), "$basename");

  }


sub new_tree
  { my $html= shift;
    my $tree= HTML::TreeBuilder::toSAX->new;

    $tree->store_comments(1);
    $tree->store_pis(1);
    $tree->store_declarations(1);

    $tree->parse_file( $html);

    return $tree;
  }

sub diff
  { my( $file1, $file2)= @_;
    my $content1= slurp( $file1);
    my $content2= slurp( $file2);
    return $content1 ne $content2;
  }

sub slurp
  { my( $file)= @_;
    local undef $/;
    open( my $fh, '<', $file) or die "cannot open '$file': $!";
    my $content= <$fh>;
    return $content;
  }
